<?php 

/**
 JustBoom Setup Controller
 @Copyright 2016 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.max2play.com

 */

include_once(APPLICATION_PATH.'/controller/Start.php');

class Justboom_Setup extends Start {

	public $scriptPath = '';
	
	public $usbSoundCards = array('' => array('dtoverlay' => '', 'name' => 'none', 'squeezelite' => '-o default:CARD=ALSA -a 120:::', 'shairport' => '-d default:CARD=ALSA', 'mpd_mixer_control' => 'PCM'),
			'justboom-digi' => array('dtoverlay' => 'justboom-digi', 'name' => 'JustBoom Digi', 'squeezelite' => '-o sysdefault:CARD=sndrpijustboomd -a 80:4::', 'shairport' => '-d sysdefault:CARD=sndrpijustboomd', 'mpd_device' => 'hw:CARD=sndrpijustboomd,DEV=0', 'mpd_mixer_control' => 'Digital'),
			'justboom-dac' => array('dtoverlay' => 'justboom-dac', 'name' => 'JustBoom DAC', 'squeezelite' => '-o sysdefault:CARD=sndrpijustboomd -a 80:4:: -o hw:CARD=sndrpijustboomd -V Digital -Q', 'shairport' => '-d sysdefault:CARD=sndrpijustboomd -t hardware -m hw:CARD=sndrpijustboomd -c Digital', 'mpd_device' => 'sysdefault:CARD=sndrpijustboomd', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpijustboomd'),
			'justboom-amp' => array('dtoverlay' => 'justboom-dac', 'name' => 'JustBoom AMP', 'squeezelite' => '-o sysdefault:CARD=sndrpijustboomd -a 80:4:: -o hw:CARD=sndrpijustboomd -V Digital -Q', 'shairport' => '-d sysdefault:CARD=sndrpijustboomd -t hardware -m hw:CARD=sndrpijustboomd -c Digital', 'mpd_device' => 'sysdefault:CARD=sndrpijustboomd', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpijustboomd')
			);		
	public $alsasettings = array(
			'justboom-dac' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
			'justboom-amp' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost'))
			);
	
	public function __construct(){				
		parent::__construct();
		$this->pluginname = _('JustBoom');
		$this->registerLocale(dirname(__FILE__).'/../locale', 'justboom');
		$this->scriptPath = dirname(__FILE__).'/../scripts/';
		
		$this->lircConfFile = '/etc/lirc/lircd.conf';
		if(file_exists('/etc/lirc/lircd.conf.d')){
		    // NEW
		    $this->lircConfFile = '/etc/lirc/lircd.conf.d/lircd.conf';
		}
		
		if($_REQUEST['ajax'] == 1){
			if ($_REQUEST['action'] == 'installKernelPi')
				$this->_installKernelPi($ajax = 1);
			ob_end_clean();
			echo implode('<br />', $this->view->message);
			ob_flush();
			die();
		}
		
		$this->checkPicturesAndHeader('justboom', dirname(__FILE__));			
		
		//Check for Kernel 4.4.y
		if(method_exists($this, 'Rpi_functions')){
		    $Rpi_functions = $this->Rpi_functions();
		    if (method_exists($Rpi_functions, 'compareKernelVersion')){
		        $updateKernel = $Rpi_functions->compareKernelVersion('4.4.1'); // needs at least 4.4.1
		    }
		}
    	if(!isset($updateKernel)){
    		$kernelversion = explode('.',trim($this->shell_exec('uname --all | grep -oe " [0-9]\+\.[0-9\.]\+"')));
    		$minkernel = array(0 => 4, 1 => 4, 2 => 1);
    		$updateKernel=false;
    		foreach($minkernel as $key => $min){
    		    if(isset($kernelversion[$key]) && $kernelversion[$key] > $min){
    		        break;
    		    }elseif(isset($kernelversion[$key]) && $kernelversion[$key] == $min){
    		        // Check further...
    		    }else{
    		        $updateKernel=true;
    		    }
    		}
    	}
		if($updateKernel && $_REQUEST['action'] != 'installKernelPi'){		
			$this->view->message[] = _t('<b>Important</b>: Justboom requires Kernel minimum 4.4.y! <a href="?action=installKernelPi">Click here to install Kernel Drivers now</a>');
		}
		// alsamixerParameter is used to get % values instead of -db (linear scale instead of exponential volume change)
		$this->alsamixerParameter = '-M';
				
		$this->_getDTOverlayConfig();
		
		if(isset($_REQUEST['action'])){
			if($_REQUEST['action'] == 'save_dtoverlay'){
				$this->_saveDtoverlay();
				$this->_getDTOverlayConfig();
			}
			if($_REQUEST['action'] == 'save_dtoverlay'){
				$this->_saveAlsa();
			}
			if($_REQUEST['action'] == 'installKernelPi'){
				$this->_installKernelPi($ajax = 0);
			}
		}
		$this->getAlsaAudio();
		$this->_rotaryEncoderHandler();
		$this->_irHandler();
		$this->_smartRemoteHandler();
		$this->easyinstaller = true;		
	}
	
	private function _getDTOverlayConfig(){
		$this->view->dtoverlay = $this->getConfigFileParameter('/opt/max2play/options.conf', 'audiocard');
		if($this->view->dtoverlay == ''){
			$this->view->message[] = _t('You have not yet choosen your installed Justboom audiocard! You must do this before you can use your audioplayers with your Justboom card! Please choose your card and finish the setup below.');
		}
		return true;
	}
	
	private function _saveDtoverlay(){
		if(isset($_REQUEST['dtoverlay']) && in_array($_REQUEST['dtoverlay'], array_keys($this->usbSoundCards)) && $this->view->dtoverlay != $_REQUEST['dtoverlay']){										
			//$this->saveConfigFileParameter('/boot/config.txt', 'dtoverlay', $this->usbSoundCards[$_REQUEST['dtoverlay']]['dtoverlay']);
			$this->saveDTOverlayConfig($this->usbSoundCards[$_REQUEST['dtoverlay']]['dtoverlay'], 'soundcard');
			$this->saveConfigFileParameter('/opt/max2play/options.conf', 'audiocard', $_REQUEST['dtoverlay']);
			//Set Squeezelite Parameter
			$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SQUEEZELITE_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['squeezelite']);
			$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SHAIRPORT_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['shairport']);			
			
			//MPD Parameter Justboom
			if(file_exists('/etc/mpd.conf')){
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'mixer_control', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_mixer_control'].'\"', $separator = '\\t');
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'format', $value = '\"192000:24:2\"', $separator = '\\t');
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'device', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_device'].'\"', $separator = '\\t');
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'mixer_device', $value = '\"'.$this->getSoundcardPosition('sndrpijustboomd').'\"', $separator = '\\t');
			}						
			
			$this->view->message[] = _("Boot config parameters changed");
			$this->view->message[] = str_replace('$SERVERIP', $this->getServerUrl($ipv4=true), _('Please restart your device! To restart now <a href="http://$SERVERIP/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl='.urlencode('http://').'$SERVERIP">just click here</a>.'));
		}		
		return true;
	}
	
	/**
	 * get soundcard position e.g. hw:0 or hw:1
	 * TODO: Problem: before card is loaded, no position is existing... -> Message Output
	 * @param string $soundcard
	 * @return string for MPD mixer_device
	 */
	private function getSoundcardPosition($soundcard = ''){
		$aplayOutput = $this->writeDynamicScript(array('aplay -l | grep "card"'));
		//card 0: ALSA [bcm2835 ALSA], device 1: bcm2835 ALSA [bcm2835 IEC958/HDMI]
		//card 1: IQaudIODAC [IQaudIODAC], device 0: IQaudIO DAC HiFi pcm512x-hifi-0 []
		if(!preg_match_all('=^card ([0-9]): ([^ ]*)=im', $aplayOutput, $aplayMatches))
			return 'default';
		$count = count($aplayMatches[1]);
		$aplayCards = array();
		for($i = 0; $i < $count; $i++){
			$aplayCards[$aplayMatches[2][$i]] = $aplayMatches[1][$i];
		}
		if(isset($aplayCards[$soundcard]))
			return 'hw:'.$aplayCards[$soundcard];
		else{
			$this->view->message[] = _("Card driver is not loaded yet! Please reboot and choose soundcard again to make sure MPD uses the correct card for volume settings!");
			return 'hw:1';
		}			
	}
	
	/**
	 * Change Kernel for drivers on Raspberry Pi
	 * @param number $ajax
	 * @return boolean
	 */
	private function _installKernelPi($ajax = 0){
		$outfile = '/opt/max2play/cache/upgradeSystem.txt';
		if($ajax == 0){
			ignore_user_abort(true);
			set_time_limit(3000);
			$this->view->message[] = _('Kernel Update started');
			if($this->getProgressWithAjax($outfile, 1, 0)){
				//run it as a deamon to enable apache updates
				$shellanswer = $this->writeDynamicScript(array("rpi-update >> ".$outfile." 2>&1;echo 'Finished - Reboot needed! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/justboom/controller/Setup.php\">Click here to Reboot Now</a></b>' >> ".$outfile), false, true);
			}
		}else{
			$status = $this->getProgressWithAjax($outfile, 0, 0, 30);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'Finished') !== FALSE){
				//Finished Progress - did not delete progressfile
				shell_exec('rm '.$outfile);
			}
		}
		return true;
	}
	
	/**
	 * get Alsa Settings For AudioCard
	 */
	public function getAlsaAudio(){
		$this->view->alsavalues = false;
		if($this->view->dtoverlay && isset($this->alsasettings[$this->view->dtoverlay])){
			$user = $this->getSystemUser();
			if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
				$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
			}else{
				$amixercard = '';
			}
			foreach($this->alsasettings[$this->view->dtoverlay] as $key => $value){				
				$script = array('su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' sget "'.$key.'"\'');
				$output = $this->writeDynamicScript($script);
				preg_match('=\[([^\]]*)\]=', $output, $match);
				if(isset($match[1])){
					$this->view->alsavalues[$key] = $value;
					if(strpos($match[1], '%') !== FALSE)
						$this->view->alsavalues[$key]['type'] = '%';
					else
						$this->view->alsavalues[$key]['type'] = '';
					$this->view->alsavalues[$key]['value'] = intval($match[1]);
				}
			}
		}		
		return true;
	}
	
	public function _saveAlsa(){
		$user = $this->getSystemUser();
		$this->getAlsaAudio();
		$script = array();
		if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
			$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
		}else{
			$amixercard = '';
		}		
		foreach($this->view->alsavalues as $key => $value){
			$script[] = 'su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' -q set "'.$key.'" '.$_REQUEST[str_replace(' ','_', $key)].$value['type'].'\'';
			$script[] = 'su - '.$user.' -c \'alsactl store\'';
		}		
		if(isset($script[0])){
			$output = nl2br($this->writeDynamicScript($script));
			if($output != '')
				$this->view->message[] = $output;
			$this->view->message[] = _("Updated Alsa Settings");
		}
		return true;
	}
	
	public function _autostartRotaryEncoder(){
		$this->selectAutostart(isset($_REQUEST['autostartrotaryencoder']) ? 1 : 0, true, 'ROTARY_ENCODER_AUTOSTART');
		return true;
	}
	
	public function _setupRotaryEncoder(){
		$this->selectAutostart(1, true, 'ROTARY_ENCODER_AUTOSTART');
		$this->view->message[] = nl2br($this->writeDynamicScript(array($this->scriptPath .'install_rotary_encoder.sh')));
		return true;
	}
	
	public function _rotaryEncoderHandler(){
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'install_rotaryencoder'){
			$this->_setupRotaryEncoder();
		}
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_autostart_rotaryencoder'){
			$this->_autostartRotaryEncoder();
			$this->saveConfigFileParameter('/opt/max2play/options.conf', $parameter = 'ROTARY_ENCODER_OPTIONS', $value = $_REQUEST['rotaryEncoderCommandline']);
			$this->view->message[] = str_replace('$SERVERIP', $this->getServerUrl($ipv4=true), _('Please restart your device! To restart now <a href="http://$SERVERIP/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl='.urlencode('http://').'$SERVERIP">just click here</a>.'));
		}
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'restart_rotaryencoder'){
			$this->saveConfigFileParameter('/opt/max2play/options.conf', $parameter = 'ROTARY_ENCODER_OPTIONS', $value = $_REQUEST['rotaryEncoderCommandline']);
			$this->rotaryEncoderCommandline = $this->getConfigFileParameter('/opt/max2play/options.conf', 'ROTARY_ENCODER_OPTIONS');
			$this->view->message[] = $this->writeDynamicScript(array('killall piRotEnc;/opt/max2play/piRotEnc/piRotEnc '.$this->rotaryEncoderCommandline.' > /dev/null &'));
		}
		
		// Check for running Script
		if(!file_exists('/opt/max2play/piRotEnc/piRotEnc')){
			$this->rotaryEncoderOptions = false;
			return false;
		}
		$this->rotaryEncoderPID = $this->status("piRotEnc");
		$this->rotaryEncoderOptions = (trim(shell_exec('/opt/max2play/piRotEnc/piRotEnc -O')));
		$this->rotaryEncoderCommandlinOptions = (trim(shell_exec('/opt/max2play/piRotEnc/piRotEnc -?')));
		$this->rotaryEncoderCommandline = $this->getConfigFileParameter('/opt/max2play/options.conf', 'ROTARY_ENCODER_OPTIONS');
		$this->autostartrotaryencoder = $this->checkAutostart('ROTARY_ENCODER_AUTOSTART', true);
		return true;
	}
	
	/**
	 * IR Handler
	 * @return boolean
	 */
	public function _irHandler(){
		$this->irMode = $this->getConfigFileParameter('/opt/max2play/options.conf', 'IR_MODE');
		
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'install_ir'){
			$this->_installIR($_REQUEST['iroption']);
		}
		
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_irButtonConfig'){
			$this->_saveIrButtonConfig();
		}
		
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_irButtonReset'){
			$this->_saveIrButtonConfig($reset = true);
		}
		
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_irLircConfig'){
			$this->_saveIrLircConfig();
		}	
		
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_irLircReset'){
			$this->_saveIrLircConfig($reset = true);
		}
			
		$this->irPID = $this->status("irexec");
		if(!$this->irPID)
			$this->irPID = $this->status("irxevent");
				
		if($this->irMode){
			$this->irConfig = $this->shell_exec('cat '.$this->scriptPath.'ir/my_lirc'.$this->irMode);
		}
		$this->irLircConfig = $this->shell_exec('cat '. $this->lircConfFile);
		return true;
	}

	private function _restartIr(){
		if($this->irMode == 'squeezelite'){
			// Restart Squeezelite
			$this->stop('squeezelite');
			sleep(2);
			$this->start('squeezelite');
		}elseif($this->irMode == 'jivelite'){
			$this->view->message[] = $this->writeDynamicScript(array('killall irxevent;export DISPLAY=:0;sudo su -l pi -c "irxevent -d '.$this->scriptPath.'/ir/my_lircjivelite"'));
		}elseif($this->irMode == 'mpd'){
			$this->view->message[] = $this->writeDynamicScript(array('killall irexec;export DISPLAY=:0;sudo su -l pi -c "irexec -d '.$this->scriptPath.'/ir/my_lircmpd"'));
		}
		return true;
	}

	/**
	 * @return boolean
	 */
	private function _saveIrButtonConfig($reset = false){
		if(isset($_REQUEST['irButtonConfig'])){
			if($reset){
				$this->view->message[] = shell_exec('cp -f '.$this->scriptPath.'ir/lirc'.$this->irMode.' '.$this->scriptPath.'ir/my_lirc'.$this->irMode);
			}else{
				if(file_put_contents($this->scriptPath.'ir/my_lirc'.$this->irMode, str_replace(array('<//textarea>',"\r"),array('</textarea>', ''),$_REQUEST['irButtonConfig']))){
					$this->view->message[] = _t('Saved Button Configuration').' '.$this->irMode;
				}
			}		
			$this->_restartIr();
		}
		
		return true;
	}
	
	private function _saveIrLircConfig($reset = false){
		if(isset($_REQUEST['irLircConfig'])){
			if($reset){
			    $this->view->message[] = $this->writeDynamicScript(array('cp -f '.$this->scriptPath.'ir/lircd.conf '.$this->lircConfFile.'; chmod 777 '.$this->lircConfFile.';'));
			}else{
			    if(file_put_contents($this->lircConfFile, str_replace(array('<//textarea>',"\r"),array('</textarea>', ''),$_REQUEST['irLircConfig']))){
					$this->view->message[] = _t('Saved Lirc Remote Configuration');
				}
			}
			$this->view->message[] = $this->writeDynamicScript(array('/etc/init.d/lirc restart'));
		}
		$this->_restartIr();
		return true;
	}
	
	
	public function _smartRemoteHandler(){	   	    
	    if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_smartRemoteConfig'){
	        $this->_saveSmartRemoteMapping();
	    }
	    
	    if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save_smartRemoteReset'){
	        $this->_saveSmartRemoteMapping($reset = true);
	    }
	    
	    if(file_exists('/etc/udev/hwdb.d/90-custom-justboom.hwdb')){
	        $this->smartRemoteConfig = $this->shell_exec('cat /etc/udev/hwdb.d/90-custom-justboom.hwdb');
	    }else{
	        $this->smartRemoteConfig = false;
	    }
	    return true;
	}
	
	
	/**
	 *  Debug Keys on X-Server Window from Console (hold shift to see some keys): xev -event keyboard
	 *  Add support for all jivelite keys for Smartremote Justboom
	 *  Keybindings Jivelite https://github.com/ralph-irving/tcz-lirc/blob/master/jivekeys.csv
	 *  Codes https://github.com/PiSupply/JustBoom#smart-remote-hex-codes
	 */
	private function _saveSmartRemoteMapping($reset = false){
	    if($reset || !file_exists('/etc/udev/hwdb.d/90-custom-justboom.hwdb')){
	        $output = $this->writeDynamicScript(array('cp -f '.$this->scriptPath.'90-custom-justboom.hwdb /etc/udev/hwdb.d/;chmod 777 /etc/udev/hwdb.d/90-custom-justboom.hwdb;'));
	        $this->view->message[] = _t('Created SmartRemote Mapping');
	        $this->view->message[] = $output;
	    }
	    
	    // Save from input!
	    if(!$reset && isset($_REQUEST['smartRemoteConfig'])){       
	        if(file_put_contents('/etc/udev/hwdb.d/90-custom-justboom.hwdb', str_replace(array('<//textarea>',"\r"),array('</textarea>', ''),$_REQUEST['smartRemoteConfig']))){
	                $this->view->message[] = _t('Saved SmartRemote Configuration');
	        }
	    }
	
	    // Reload udev
	    $this->writeDynamicScript(array('sudo systemd-hwdb update && sudo udevadm trigger'));
	    $this->view->message[] = _t('Mapping saved');
	}
	
	/**
	 * Installer for IR depending on Option for squeezelite,jivelite,mpd
	 * @param string $option
	 */
	private function _installIR($option = ''){
	    $kernelOld = true;
	    if(method_exists($this, 'Rpi_functions')){
    	    $Rpi_functions = $this->Rpi_functions();
    	    if (method_exists($Rpi_functions, 'compareKernelVersion')){
    	        $kernelOld = $Rpi_functions->compareKernelVersion('4.19.30'); // new GPIO_IR needs at least 4.19.30 in Max2Play
    	    }
	    }
	    if(!$kernelOld){
	        $this->saveDTOverlayConfig('gpio-ir', 'lirc', 'gpio_pin=25');	        
	    }else{
	        $this->saveDTOverlayConfig('lirc-rpi', 'lirc', 'gpio_in_pin=25');
	    }
	    $this->view->message[] = _t("GPIO Pin for IR is set to 25");
		$this->view->message[] = nl2br($this->writeDynamicScript(array($this->scriptPath .'install_ir.sh '.$option)));
		$this->saveConfigFileParameter('/opt/max2play/options.conf', $parameter = 'IR_MODE', $value = $option);
		$this->irMode = $this->getConfigFileParameter('/opt/max2play/options.conf', 'IR_MODE');
		return true;
	}
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - JustBoom Edition');
		$helpSidebar['content'] = _t('<ul><li>Choose your setup and easily configure your audiosettings with this special Max2Play-Version. For video tutorials and more about Max2Play visit www.max2play.com</li></ul>');
		$helpSidebar['toppicture'] = '/images/start-toppicture.jpg';
		return true;
	}	
	
	/**
	 * Important! dtoverlay Parameter might be set multiple times in config.txt -> separate handling needed
	 * @param string $value
	 * @param string $dto_type Possible values: soundcard, single_option
	 * @return boolean
	 */
	private function saveDTOverlayConfig($value = '', $dto_type = 'notset', $dto_param = ''){
	    $dto_entries['soundcard'] = array();	    
	    
		// NEW Method!
		if(method_exists($this, 'Rpi_functions')){
			$Rpi_functions = $this->Rpi_functions();
			if($dto_param != '') // For Lirc
				$value = $value.','.$dto_param;
			$rpi_Object = get_object_vars($Rpi_functions);
			if(isset($rpi_Object['usbSoundCards'])){
			    foreach($rpi_Object['usbSoundCards'] as $card){
			        if (isset($card['dtoverlay']) && $card['dtoverlay'] != '')
			            $dto_entries['soundcard'][] = $card['dtoverlay'];
			    }
			}
			// Bugfix for Private Method in RPI-Functions...
			if(in_array('saveDTOverlayConfig', get_class_methods($Rpi_functions))){
			    $Rpi_functions->saveDTOverlayConfig($value, $dto_type);
			    return true;
			}			
		}
		// Old Method - Remove when obsolete
		
		$dto_entries['i2s-mmap'] = array('i2s-mmap'); // Support for Alsa DMIX on Soundcards
		$dto_entries['bluetooth'] = array('pi3-disable-bt');
		$dto_entries['lirc'] = array('lirc-rpi');
		$dto_value = '';
		$separator = '=';
		$configfile = '/boot/config.txt';
		$parameter = 'dtoverlay';
		// fill possible soundcard values
		foreach($this->usbSoundCards as $card){
			if (isset($card['dtoverlay']) && $card['dtoverlay'] != '')
				$dto_entries['soundcard'][] = $card['dtoverlay'];
		}
		if(file_exists($configfile)){
			$old_parameter = explode("\n", trim($this->getConfigFileParameter($configfile, $parameter)));
			// $old_parameter is an array
			// get the right value to replace / add new
			foreach($old_parameter as $oldparam){
				if(in_array($oldparam, $dto_entries[$dto_type])){
					$dto_value = $oldparam;
				}
				if($oldparam == $value){
					//Value existing -> do not change!
					return true;
				}
			}
				
			if($dto_value != '' && $value == ''){
				// Remove by oldvalue
				$this->writeDynamicScript(array('sed -i "s/^[ \t]*'.$parameter.$separator.$dto_value.'$//g" '.$configfile));
				$this->view->message[] = _("Update Configfile - existing Entry removed");
			}elseif($dto_value == ''){
				// Add new
				$this->writeDynamicScript(array('echo "'.$parameter.$separator.$value.'" >> '.$configfile));
				//TODO remove Dirty Hack - works only the first time
				if($dto_param != '')
					$this->writeDynamicScript(array('echo "dtparam='.$dto_param.'" >> '.$configfile));
				$this->view->message[] = _("Update Configfile - new Entry created");
			}else{
				// Replace by old value
				$this->writeDynamicScript(array('sed -i "s/^[ \t]*'.$parameter.$separator.$dto_value.'$/'.$parameter.$separator.str_replace(array('/'),array('\/'),$value).'/g" '.$configfile));
				$this->view->message[] = _("Update Configfile - existing Entry changed");
			}
		}
		return true;
	}
}

$start = new Justboom_Setup();

include_once(dirname(__FILE__).'/../view/setup.php');

