#!/bin/bash
apt-get update
apt-get install wiringPi --yes --force-yes

# Connection details: http://theatticlight.net/posts/Reading-a-Rotary-Encoder-from-a-Raspberry-Pi/
# Sources Repository: https://github.com/alidaf/raspberryPi.git

######## Compile from source ########
# pushd /opt
# mkdir rotenc
# pushd /opt/rotenc
# git clone https://github.com/alidaf/raspberryPi.git
# pushd /opt/rotenc/raspberryPi/piRotEnc
# edit rotencPi.c: setenv("WIRINGPI_GPIOMEM", "1", 1);
# gcc piRotEnc.c alsaPi.c rotencPi.c -o piRotEnc -lwiringPi -lasound -lm -lpthread
# cp -f /opt/rotenc/raspberryPi/piRotEnc /opt/max2play/

####### Get Precompiled from Server ##########
wget -O /opt/max2play/cache/piRotEnc.tgz cdn.max2play.com/pi/piRotEnc.tgz
tar xzf /opt/max2play/cache/piRotEnc.tgz -C /opt/max2play/

if [ ! "$(grep -a 'ROTARY_ENCODER_OPTIONS' /opt/max2play/options.conf)" ]; then
	echo "ROTARY_ENCODER_OPTIONS=-c hw:0 -m Digital --gpiorot=23,24 --vol=60" >> /opt/max2play/options.conf
fi

if [ ! "$(grep -a 'ROTARY_ENCODER_AUTOSTART' /etc/rc.local)" ]; then
	sed -i "s@^exit 0@if [ \"\$(grep -a 'ROTARY_ENCODER_AUTOSTART=1' /opt/max2play/autostart.conf)\" ]; then \n  ROTARY_ENCODER_OPTIONS=\$(grep -a \"ROTARY_ENCODER_OPTIONS\" /opt/max2play/options.conf | sed -n -e 's/^[A-Z_]*\\=//p')\n  /opt/max2play/piRotEnc/piRotEnc \$ROTARY_ENCODER_OPTIONS \&\nfi\nexit 0@" /etc/rc.local
fi

# Optional Disable On-Board Sound to let the Encoder get the Right Soundcard for Debian Jessie Raspberry Pi
sed -i 's/^dtparam=audio=on/dtparam=audio=off/' /boot/config.txt

echo "finished - Reboot needed: <b><a href='/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/justboom/controller/Setup.php'>Click here to Restart Device</a></b>";

exit 0